diff --git a/src/mongo/db/pipeline/document_source_union_with.cpp b/src/mongo/db/pipeline/document_source/document_source_union_with.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_union_with.cpp
rename to src/mongo/db/pipeline/document_source/document_source_union_with.cpp
index 17570253cd..302c921dd2 100644
--- a/src/mongo/db/pipeline/document_source_union_with.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_union_with.cpp
@@ -33,10 +33,10 @@
 #include <iterator>
 
 #include "mongo/db/commands/test_commands_enabled.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
-#include "mongo/db/pipeline/document_source_union_with.h"
-#include "mongo/db/pipeline/document_source_union_with_gen.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_union_with.h"
+#include "mongo/db/pipeline/document_source/document_source_union_with_gen.h"
 #include "mongo/db/views/resolved_view.h"
 #include "mongo/logv2/log.h"
 
diff --git a/src/mongo/db/pipeline/document_source_union_with.h b/src/mongo/db/pipeline/document_source/document_source_union_with.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_union_with.h
rename to src/mongo/db/pipeline/document_source/document_source_union_with.h
index 02dda56665..9d0128b4a9 100644
--- a/src/mongo/db/pipeline/document_source_union_with.h
+++ b/src/mongo/db/pipeline/document_source/document_source_union_with.h
@@ -31,7 +31,7 @@
 
 #include <boost/optional.hpp>
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/pipeline/lite_parsed_pipeline.h"
 #include "mongo/db/pipeline/stage_constraints.h"
diff --git a/src/mongo/db/pipeline/document_source_union_with_test.cpp b/src/mongo/db/pipeline/document_source/document_source_union_with_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_union_with_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_union_with_test.cpp
index 4806846682..5ba12017cf 100644
--- a/src/mongo/db/pipeline/document_source_union_with_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_union_with_test.cpp
@@ -39,13 +39,13 @@
 #include "mongo/db/exec/document_value/document_comparator.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_facet.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_replace_root.h"
-#include "mongo/db/pipeline/document_source_union_with.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_facet.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_replace_root.h"
+#include "mongo/db/pipeline/document_source/document_source_union_with.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/pipeline/process_interface/stub_lookup_single_document_process_interface.h"
 #include "mongo/unittest/unittest.h"
diff --git a/src/mongo/db/pipeline/document_source_unwind.cpp b/src/mongo/db/pipeline/document_source/document_source_unwind.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_unwind.cpp
rename to src/mongo/db/pipeline/document_source/document_source_unwind.cpp
index ae0bfecbb9..cc2c7c4166 100644
--- a/src/mongo/db/pipeline/document_source_unwind.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_unwind.cpp
@@ -29,14 +29,14 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_unwind.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/matcher/expression_algo.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_unwind.h b/src/mongo/db/pipeline/document_source/document_source_unwind.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_unwind.h
rename to src/mongo/db/pipeline/document_source/document_source_unwind.h
index 9d825b213e..43924f9954 100644
--- a/src/mongo/db/pipeline/document_source_unwind.h
+++ b/src/mongo/db/pipeline/document_source/document_source_unwind.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/pipeline/field_path.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_unwind_test.cpp b/src/mongo/db/pipeline/document_source/document_source_unwind_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_unwind_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_unwind_test.cpp
index aa8a550ec0..35638124ca 100644
--- a/src/mongo/db/pipeline/document_source_unwind_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_unwind_test.cpp
@@ -43,8 +43,8 @@
 #include "mongo/db/pipeline/aggregate_command_gen.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_unwind.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_unwind.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/query_test_service_context.h"
 #include "mongo/db/service_context.h"
diff --git a/src/mongo/db/pipeline/document_source_writer.h b/src/mongo/db/pipeline/document_source/document_source_writer.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_writer.h
rename to src/mongo/db/pipeline/document_source/document_source_writer.h
index a94b4efca6..3175ba6125 100644
--- a/src/mongo/db/pipeline/document_source_writer.h
+++ b/src/mongo/db/pipeline/document_source/document_source_writer.h
@@ -35,7 +35,7 @@
 
 #include "mongo/db/db_raii.h"
 #include "mongo/db/operation_context.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/read_concern.h"
 #include "mongo/db/storage/recovery_unit.h"
 
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/create_predicates_on_bucket_level_field_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/create_predicates_on_bucket_level_field_test.cpp
index dd38554cf9..be861c4a8a 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/create_predicates_on_bucket_level_field_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/create_predicates_on_bucket_level_field_test.cpp
@@ -30,8 +30,8 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_or_build_project_to_internalize_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_or_build_project_to_internalize_test.cpp
index 3bee8e7b5b..c5e9ca777f 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_or_build_project_to_internalize_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_or_build_project_to_internalize_test.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/bson/unordered_fields_bsonobj_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 #include "mongo/unittest/bson_test_util.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_project_for_pushdown_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_project_for_pushdown_test.cpp
index 1a82b1eb31..e3e6cfba71 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_project_for_pushdown_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/extract_project_for_pushdown_test.cpp
@@ -31,8 +31,8 @@
 
 #include "mongo/bson/unordered_fields_bsonobj_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
-#include "mongo/db/pipeline/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 #include "mongo/unittest/bson_test_util.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/internalize_project_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/internalize_project_test.cpp
index c86ef45e44..706a7f6495 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/internalize_project_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/internalize_project_test.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/bson/unordered_fields_bsonobj_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/optimize_pipeline_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/optimize_pipeline_test.cpp
index abb15917f9..9c18432df6 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/optimize_pipeline_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/optimize_pipeline_test.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/bson/unordered_fields_bsonobj_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 #include "mongo/unittest/bson_test_util.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/pushdown_computed_meta_projections_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/pushdown_computed_meta_projections_test.cpp
index 3f34f8cc34..8a14c60fc6 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/pushdown_computed_meta_projections_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/pushdown_computed_meta_projections_test.cpp
@@ -32,8 +32,8 @@
 #include "mongo/bson/unordered_fields_bsonobj_comparator.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp
index 18ceba57c0..66bd52893f 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/split_match_on_meta_and_rename_test.cpp
@@ -30,8 +30,8 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
-#include "mongo/db/pipeline/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
 #include "mongo/db/pipeline/pipeline.h"
 #include "mongo/db/query/util/make_data_structure.h"
 #include "mongo/unittest/bson_test_util.h"
diff --git a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/unpack_bucket_exec_test.cpp b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/unpack_bucket_exec_test.cpp
index 3566795918..382829a647 100644
--- a/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/unpack_bucket_exec_test.cpp
+++ b/src/mongo/db/pipeline/document_source_internal_unpack_bucket_test/unpack_bucket_exec_test.cpp
@@ -29,8 +29,8 @@
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_internal_unpack_bucket.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_unpack_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/timeseries/timeseries_constants.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/expression.cpp b/src/mongo/db/pipeline/expression/expression.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression.cpp
rename to src/mongo/db/pipeline/expression/expression.cpp
index 02a73e72a9..2516ebbdc3 100644
--- a/src/mongo/db/pipeline/expression.cpp
+++ b/src/mongo/db/pipeline/expression/expression.cpp
@@ -30,7 +30,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 #include <algorithm>
 #include <boost/algorithm/string.hpp>
diff --git a/src/mongo/db/pipeline/expression.h b/src/mongo/db/pipeline/expression/expression.h
similarity index 99%
rename from src/mongo/db/pipeline/expression.h
rename to src/mongo/db/pipeline/expression/expression.h
index 9992f43aaa..84c5cf72dd 100644
--- a/src/mongo/db/pipeline/expression.h
+++ b/src/mongo/db/pipeline/expression/expression.h
@@ -45,8 +45,8 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/dependencies.h"
+#include "mongo/db/pipeline/expression/expression_visitor.h"
 #include "mongo/db/pipeline/expression_context.h"
-#include "mongo/db/pipeline/expression_visitor.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/variables.h"
 #include "mongo/db/query/datetime/date_time_support.h"
diff --git a/src/mongo/db/pipeline/expression_and_test.cpp b/src/mongo/db/pipeline/expression/expression_and_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_and_test.cpp
rename to src/mongo/db/pipeline/expression/expression_and_test.cpp
index cbfa37a77d..05ad72a4c1 100644
--- a/src/mongo/db/pipeline/expression_and_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_and_test.cpp
@@ -36,7 +36,7 @@
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/expression_bm.cpp b/src/mongo/db/pipeline/expression/expression_bm.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_bm.cpp
rename to src/mongo/db/pipeline/expression/expression_bm.cpp
index ffb4b798fd..4fd8dc8ba9 100644
--- a/src/mongo/db/pipeline/expression_bm.cpp
+++ b/src/mongo/db/pipeline/expression/expression_bm.cpp
@@ -32,7 +32,7 @@
 #include <benchmark/benchmark.h>
 
 #include "mongo/db/matcher/expression_parser.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/query_test_service_context.h"
 
diff --git a/src/mongo/db/pipeline/expression_compare_test.cpp b/src/mongo/db/pipeline/expression/expression_compare_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_compare_test.cpp
rename to src/mongo/db/pipeline/expression/expression_compare_test.cpp
index 11836d7726..0b1cded0ee 100644
--- a/src/mongo/db/pipeline/expression_compare_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_compare_test.cpp
@@ -34,7 +34,7 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/dbtests/dbtests.h"
 #include "mongo/unittest/unittest.h"
diff --git a/src/mongo/db/pipeline/expression_field_path_test.cpp b/src/mongo/db/pipeline/expression/expression_field_path_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_field_path_test.cpp
rename to src/mongo/db/pipeline/expression/expression_field_path_test.cpp
index 9fa73620df..2e82a0df97 100644
--- a/src/mongo/db/pipeline/expression_field_path_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_field_path_test.cpp
@@ -34,7 +34,7 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/dbtests/dbtests.h"
 #include "mongo/unittest/unittest.h"
diff --git a/src/mongo/db/pipeline/expression_find_internal.h b/src/mongo/db/pipeline/expression/expression_find_internal.h
similarity index 99%
rename from src/mongo/db/pipeline/expression_find_internal.h
rename to src/mongo/db/pipeline/expression/expression_find_internal.h
index 68d535e5b2..78257f1638 100644
--- a/src/mongo/db/pipeline/expression_find_internal.h
+++ b/src/mongo/db/pipeline/expression/expression_find_internal.h
@@ -33,7 +33,7 @@
 
 #include "mongo/db/exec/projection_executor_utils.h"
 #include "mongo/db/matcher/copyable_match_expression.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 /**
diff --git a/src/mongo/db/pipeline/expression_find_internal_test.cpp b/src/mongo/db/pipeline/expression/expression_find_internal_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_find_internal_test.cpp
rename to src/mongo/db/pipeline/expression/expression_find_internal_test.cpp
index 2b743d2b66..22e87f2b9a 100644
--- a/src/mongo/db/pipeline/expression_find_internal_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_find_internal_test.cpp
@@ -32,7 +32,7 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/projection_executor.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/expression_find_internal.h"
+#include "mongo/db/pipeline/expression/expression_find_internal.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo::expression_internal_tests {
diff --git a/src/mongo/db/pipeline/expression_function.cpp b/src/mongo/db/pipeline/expression/expression_function.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_function.cpp
rename to src/mongo/db/pipeline/expression/expression_function.cpp
index e28acaca61..6b9a41666f 100644
--- a/src/mongo/db/pipeline/expression_function.cpp
+++ b/src/mongo/db/pipeline/expression/expression_function.cpp
@@ -27,7 +27,7 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/expression_function.h"
+#include "mongo/db/pipeline/expression/expression_function.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/expression_function.h b/src/mongo/db/pipeline/expression/expression_function.h
similarity index 98%
rename from src/mongo/db/pipeline/expression_function.h
rename to src/mongo/db/pipeline/expression/expression_function.h
index d570bdfbc8..426d225f0b 100644
--- a/src/mongo/db/pipeline/expression_function.h
+++ b/src/mongo/db/pipeline/expression/expression_function.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/javascript_execution.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/expression_javascript_test.cpp b/src/mongo/db/pipeline/expression/expression_javascript_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_javascript_test.cpp
rename to src/mongo/db/pipeline/expression/expression_javascript_test.cpp
index dc0df7cb51..63d773923d 100644
--- a/src/mongo/db/pipeline/expression_javascript_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_javascript_test.cpp
@@ -27,13 +27,13 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/expression_js_emit.h"
+#include "mongo/db/pipeline/expression/expression_js_emit.h"
 
 #include "mongo/db/commands/test_commands_enabled.h"
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
+#include "mongo/db/pipeline/expression/expression_function.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
-#include "mongo/db/pipeline/expression_function.h"
 #include "mongo/db/pipeline/process_interface/standalone_process_interface.h"
 #include "mongo/db/query/query_knobs_gen.h"
 #include "mongo/db/service_context_d_test_fixture.h"
diff --git a/src/mongo/db/pipeline/expression_js_emit.cpp b/src/mongo/db/pipeline/expression/expression_js_emit.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_js_emit.cpp
rename to src/mongo/db/pipeline/expression/expression_js_emit.cpp
index 44242fefcf..fd6dca2774 100644
--- a/src/mongo/db/pipeline/expression_js_emit.cpp
+++ b/src/mongo/db/pipeline/expression/expression_js_emit.cpp
@@ -30,7 +30,7 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/auth/authorization_session.h"
-#include "mongo/db/pipeline/expression_js_emit.h"
+#include "mongo/db/pipeline/expression/expression_js_emit.h"
 #include "mongo/db/pipeline/make_js_function.h"
 #include "mongo/db/query/query_knobs_gen.h"
 
diff --git a/src/mongo/db/pipeline/expression_js_emit.h b/src/mongo/db/pipeline/expression/expression_js_emit.h
similarity index 98%
rename from src/mongo/db/pipeline/expression_js_emit.h
rename to src/mongo/db/pipeline/expression/expression_js_emit.h
index 7aebbf3cb1..f2d55c768e 100644
--- a/src/mongo/db/pipeline/expression_js_emit.h
+++ b/src/mongo/db/pipeline/expression/expression_js_emit.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/javascript_execution.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/expression_nary_test.cpp b/src/mongo/db/pipeline/expression/expression_nary_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_nary_test.cpp
rename to src/mongo/db/pipeline/expression/expression_nary_test.cpp
index e69fc26cc3..7953439754 100644
--- a/src/mongo/db/pipeline/expression_nary_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_nary_test.cpp
@@ -36,7 +36,7 @@
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/expression_object_test.cpp b/src/mongo/db/pipeline/expression/expression_object_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_object_test.cpp
rename to src/mongo/db/pipeline/expression/expression_object_test.cpp
index 7246e9569e..615683ab16 100644
--- a/src/mongo/db/pipeline/expression_object_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_object_test.cpp
@@ -36,7 +36,7 @@
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/expression_or_test.cpp b/src/mongo/db/pipeline/expression/expression_or_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_or_test.cpp
rename to src/mongo/db/pipeline/expression/expression_or_test.cpp
index ca4f5fdf84..fd3e7ccc8a 100644
--- a/src/mongo/db/pipeline/expression_or_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_or_test.cpp
@@ -36,7 +36,7 @@
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/expression_replace_test.cpp b/src/mongo/db/pipeline/expression/expression_replace_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_replace_test.cpp
rename to src/mongo/db/pipeline/expression/expression_replace_test.cpp
index df5e19e784..20bce54fdd 100644
--- a/src/mongo/db/pipeline/expression_replace_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_replace_test.cpp
@@ -33,7 +33,7 @@
 
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/expression_test.cpp b/src/mongo/db/pipeline/expression/expression_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_test.cpp
rename to src/mongo/db/pipeline/expression/expression_test.cpp
index 88672eec4c..994d16083b 100644
--- a/src/mongo/db/pipeline/expression_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_test.cpp
@@ -39,8 +39,8 @@
 #include "mongo/db/hasher.h"
 #include "mongo/db/jsobj.h"
 #include "mongo/db/json.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/db/query/collation/collator_interface_mock.h"
 #include "mongo/dbtests/dbtests.h"
diff --git a/src/mongo/db/pipeline/expression_test_api_version.cpp b/src/mongo/db/pipeline/expression/expression_test_api_version.cpp
similarity index 98%
rename from src/mongo/db/pipeline/expression_test_api_version.cpp
rename to src/mongo/db/pipeline/expression/expression_test_api_version.cpp
index 7c77895bff..14864e4967 100644
--- a/src/mongo/db/pipeline/expression_test_api_version.cpp
+++ b/src/mongo/db/pipeline/expression/expression_test_api_version.cpp
@@ -29,7 +29,7 @@
 #include "mongo/platform/basic.h"
 
 #include "mongo/db/api_parameters.h"
-#include "mongo/db/pipeline/expression_test_api_version.h"
+#include "mongo/db/pipeline/expression/expression_test_api_version.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/expression_test_api_version.h b/src/mongo/db/pipeline/expression/expression_test_api_version.h
similarity index 98%
rename from src/mongo/db/pipeline/expression_test_api_version.h
rename to src/mongo/db/pipeline/expression/expression_test_api_version.h
index a78464dff4..b710d4dae7 100644
--- a/src/mongo/db/pipeline/expression_test_api_version.h
+++ b/src/mongo/db/pipeline/expression/expression_test_api_version.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 /**
diff --git a/src/mongo/db/pipeline/expression_test_api_version_test.cpp b/src/mongo/db/pipeline/expression/expression_test_api_version_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/expression_test_api_version_test.cpp
rename to src/mongo/db/pipeline/expression/expression_test_api_version_test.cpp
index 05c9156ddf..eb49032789 100644
--- a/src/mongo/db/pipeline/expression_test_api_version_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_test_api_version_test.cpp
@@ -32,7 +32,7 @@
 #include "mongo/db/pipeline/expression_context_for_test.h"
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/expression_test_api_version.h"
+#include "mongo/db/pipeline/expression/expression_test_api_version.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/expression_trigonometric_test.cpp b/src/mongo/db/pipeline/expression/expression_trigonometric_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/expression_trigonometric_test.cpp
rename to src/mongo/db/pipeline/expression/expression_trigonometric_test.cpp
index 5a37a78a21..138d82ce65 100644
--- a/src/mongo/db/pipeline/expression_trigonometric_test.cpp
+++ b/src/mongo/db/pipeline/expression/expression_trigonometric_test.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/expression_trigonometric.h"
+#include "mongo/db/pipeline/expression/expression_trigonometric.h"
 
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/expression_context_for_test.h"
